Liferay.Loader.define('@questions-web$apollo/client@3.0.0-beta.50/utilities/observables/asyncMap', ['module', 'exports', 'require'], function (module, exports, require) {
    var define = undefined;
    var global = window;
    {
        import Observable from 'zen-observable';
        import 'symbol-observable';

        function asyncMap(observable, mapFn, catchFn) {
            return new Observable(function (observer) {
                var next = observer.next,
                    error = observer.error,
                    complete = observer.complete;
                var activeCallbackCount = 0;
                var completed = false;
                function makeCallback(examiner, delegate) {
                    if (examiner) {
                        return function (arg) {
                            ++activeCallbackCount;
                            new Promise(function (resolve) {
                                return resolve(examiner(arg));
                            }).then(function (result) {
                                --activeCallbackCount;
                                next && next.call(observer, result);
                                if (completed) {
                                    handler.complete();
                                }
                            }, function (e) {
                                --activeCallbackCount;
                                error && error.call(observer, e);
                            });
                        };
                    } else {
                        return function (arg) {
                            return delegate && delegate.call(observer, arg);
                        };
                    }
                }
                var handler = {
                    next: makeCallback(mapFn, next),
                    error: makeCallback(catchFn, error),
                    complete: function () {
                        completed = true;
                        if (!activeCallbackCount) {
                            complete && complete.call(observer);
                        }
                    }
                };
                var sub = observable.subscribe(handler);
                return function () {
                    return sub.unsubscribe();
                };
            });
        }

        export { asyncMap };
        //# sourceMappingURL=asyncMap.js.map
    }
});
//# sourceMappingURL=asyncMap.js.map