Liferay.Loader.define('questions-web$highlight.js@10.4.1/lib/languages/subunit', ['module', 'exports', 'require'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    /*
    Language: SubUnit
    Author: Sergey Bronnikov <sergeyb@bronevichok.ru>
    Website: https://pypi.org/project/python-subunit/
    */

    function subunit(hljs) {
      return {
        name: 'SubUnit',
        case_insensitive: true,
        contains: [{
          className: 'string',
          begin: '\\[\n(multipart)?',
          end: '\\]\n'
        }, {
          className: 'string',
          begin: '\\d{4}-\\d{2}-\\d{2}(\\s+)\\d{2}:\\d{2}:\\d{2}\.\\d+Z'
        }, {
          className: 'string',
          begin: '(\\+|-)\\d+'
        }, {
          className: 'keyword',
          relevance: 10,
          variants: [{
            begin: '^(test|testing|success|successful|failure|error|skip|xfail|uxsuccess)(:?)\\s+(test)?'
          }, {
            begin: '^progress(:?)(\\s+)?(pop|push)?'
          }, {
            begin: '^tags:'
          }, {
            begin: '^time:'
          }]
        }]
      };
    }

    module.exports = subunit;
  }
});
//# sourceMappingURL=subunit.js.map