Liferay.Loader.define('questions-web$highlight.js@10.4.1/lib/languages/taggerscript', ['module', 'exports', 'require'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    /*
    Language: Tagger Script
    Author: Philipp Wolfer <ph.wolfer@gmail.com>
    Description: Syntax Highlighting for the Tagger Script as used by MusicBrainz Picard.
    Website: https://picard.musicbrainz.org
     */
    function taggerscript(hljs) {
      const COMMENT = {
        className: 'comment',
        begin: /\$noop\(/,
        end: /\)/,
        contains: [{
          begin: /\(/,
          end: /\)/,
          contains: ['self', {
            begin: /\\./
          }]
        }],
        relevance: 10
      };

      const FUNCTION = {
        className: 'keyword',
        begin: /\$(?!noop)[a-zA-Z][_a-zA-Z0-9]*/,
        end: /\(/,
        excludeEnd: true
      };

      const VARIABLE = {
        className: 'variable',
        begin: /%[_a-zA-Z0-9:]*/,
        end: '%'
      };

      const ESCAPE_SEQUENCE = {
        className: 'symbol',
        begin: /\\./
      };

      return {
        name: 'Tagger Script',
        contains: [COMMENT, FUNCTION, VARIABLE, ESCAPE_SEQUENCE]
      };
    }

    module.exports = taggerscript;
  }
});
//# sourceMappingURL=taggerscript.js.map